PAGE 60,132
.8086
if1
  include csgmacro.inc
endif
; --------------------- Language Interface -----------------------
; Note: This module is not intended to be used with turbo pascal.
;	The language definition is included for macro reasons.
; Choices:
MICROSOFT	EQU	0
RYAN_MCFARLAND	EQU	1
TURBO_PASCAL	EQU	2
GPX_DRIVER	EQU	3
;
LANGUAGE	EQU	MICROSOFT
; ------------------------- Code segment -------------------------
;
START_CODE_SEG	LANGUAGE,ST2BIN 			; macro
; //////////////////// Local Data Definitions ////////////////////
hex_list	db  '0','1','2','3','4','5','6','7','8','9'
		db  'A','B','C','D','E','F'
; ////////////////////////////////////////////////////////////////
; ASSEMBLY ROUTINE ST2BIN( str , len , type , bval )
; This converts the string into a 16 bit binary number.
; It is intended to be used with languages that do not
; provide hex or binary notation.
; ================================================================
ENTERP	ST2BIN,FarPro,<ax,bx,cx,dx,si,di,es>
; get string length
	GET_ARG cx,2,4				; put length in CX
;
	push	cx
;------------------ Get Address Of String ---------
if LANGUAGE eq MICROSOFT
	les	bx,[bp+18]
endif
if LANGUAGE eq RYAN_MCFARLAND
	les	bx,argblkptr		; point to argument block
	les	bx,es:[bx]		; point to descriptor
	les	bx,es:[bx+2]		; point to string
endif
;------------------ Check Case
; main loop
	jcxz	ufin			; if length is 0 return
ulp1:	mov	al,es:[bx]
	cmp	al,'a'
	jb	unextc
	cmp	al,'z'
	ja	unextc
;
	and	al,5fH
	mov	es:[bx],al		; put byte back
unextc: inc	bx
	loop	ulp1
ufin:	pop	cx
;----------------------------------
; get type
if LANGUAGE eq MICROSOFT
	les	bx,[bp+10]
endif
if LANGUAGE eq RYAN_MCFARLAND
	les	bx,argblkptr		; point to argument block
	les	bx,es:[bx+8]		; point to descriptor
	les	bx,es:[bx+2]		; point to string
endif
	or	byte ptr es:[bx],32	; convert to lower case
	cmp	byte ptr es:[bx],'h'	; check for hex conversion
	jz	hex
; /////////////////////////// binary conversion //////////////////////
bin:	cld			; set forward operation
; point es:si at base of string
if LANGUAGE eq MICROSOFT
	les	si,[bp+18]
endif
if LANGUAGE eq RYAN_MCFARLAND
	les	si,argblkptr		; point to argument block
	les	si,es:[si]		; point to descriptor
	les	si,es:[si+2]		; point to string
endif
;-------
	mov	dx,0000h
	mov	bx,1
	push	cx
	dec	cx
	rol	bx,cl
	pop	cx
lp1:	mov	al,es:[si]		; get char
	inc	si
	cmp	al,'1'			; if not a 1, assume 0
	jnz	shf1
	or	dx,bx
shf1:	shr	bx,1			; shift
	loop	lp1
;
	SET_ESOFBX  4,4 		; point to "bval"
	mov	es:[bx],dx		; dx contains value
	jmp	exit
; ///////////////////////// hexadecimal conversion //////////////////
hex:
	push	ds
	mov	ax,ds
	mov	es,ax			; point ES: at local data
if LANGUAGE eq MICROSOFT
	lds	si,[bp+18]		; point es:si at base of string
endif
if LANGUAGE eq RYAN_MCFARLAND
	lds	si,argblkptr		; point to argument block
	lds	si,[si]			; point to descriptor
	lds	si,[si+2]		; point to string
endif
	mov	dx,0			; initialize dx
ml1:	lea	di,hex_list+15
	cld
	lodsb				; get char
	push	cx
	mov	cl,0Fh
	std
	repnz	scasb
	jnz	j1
	inc	cx
j1:	or	dx,cx
	pop	cx
	cmp	cx,1
	jz	next
	rol	dx,1
	rol	dx,1
	rol	dx,1
	rol	dx,1
next:	loop	ml1
;
	pop	ds
	SET_ESOFBX  4,4 		; point to "bval"
	mov	es:[bx],dx		; dx contains value
;
exit:
EXITP	ST2BIN,FarPro,<es,di,si,dx,cx,bx,ax>,4
; ----------------------------------------------------------------
END_CODE_SEG
	end

        

